# Recipes
import os
from msvcrt import getch
from ast import literal_eval as make_tuple

# list of recipes in the file
recipe_names = []
# current recipe
recipe = []
# has the user finished?
keep_going = True

# function to clear screen (taken from stackoverflow.com)
def clear():
    os.system('cls' if os.name == 'nt' else 'clear')
    
# read recipe names into a list
def find_recipe_names():
    global recipe_names
    recipe_names = []
    temp = ()
    with open('recipes.txt','r') as f:
        for line in f:
            temp = make_tuple(line)
            recipe_names.append(temp[0])
    recipe_names.sort()
    
# read ingredients for original recipe
def find_recipe(name):
    global recipe
    temp = ()
    f = open('recipes.txt','r')
    recipe_name = ""
    while recipe_name != name:
        recipe = make_tuple(f.readline())
        recipe_name = str(recipe[0])
    f.close()

# adjust recipe for a different number of people
def scale_recipe(recipe_no, people):
    global recipe, recipe_names
    clear()
    find_recipe(recipe_names[recipe_no-1])
    print recipe[0].upper(),"for",people,"people\n"
    scale = people/float(recipe[1])
    col_width = max(len(str(i)) for i in recipe)
    i = 2
    while i < len(recipe)-2:
        if recipe[i+1]*scale < 10 and recipe[i+1]*scale != int(recipe[i+1]*scale):
            amount = int(recipe[i+1]*scale * 10)/float(10)
        else:
            amount = int(recipe[i+1]*scale)
        print recipe[i].title(), " "*(col_width - len(recipe[i])), amount, recipe[i+2]
        i += 3
    print("\nPress any key to return to the main menu")
    option = getch()

# append a new recipe to the file
def save_recipe():
    global recipe
    f = open('recipes.txt','a')
    f.write(str(recipe)+"\n")
    f.close()

# display the new recipe menu and options
def new_recipe():
    global recipe
    clear()
    recipe = []
    print("R E C I P E - T R O N\n   Add New Recipe\n")
    print("1 - Add New Recipe")
    print("0 - Back to Main Menu\n")
    option = getch()
    while ord(option) < 48 or ord(option) > 49:
        option = getch()
    if option == "1":
        response = raw_input("What is the name of your recipe? ")
        recipe.append(response)
        response = ask("How many people does your recipe typically serve? ")
        while response <= 0 or int(response) != response:
            response = ask("Please enter a whole number greater than zero: ")
        recipe.append(response)
        more = True
        print("\nYou will now be asked for the list of ingredients.\nLeave the ingredient name blank to finish.\n")
        while more:
            ingredient = []
            response = raw_input("Name of ingredient: ")
            if response != "":
                ingredient.append(response)
                response = raw_input("What are the units used to measure "+ingredient[0]+"? ")
                ingredient.append(response)
                if response > "":
                    response = ask("How many "+ingredient[1]+"s? ")
                else:
                    response = ask("How many? ")
                while response <= 0:
                    response = ask("Please enter a number greater than zero: ")
                ingredient.insert(1, response)
                recipe.extend(ingredient)
                print("")
            else:
                more = False
        print("\nPress 1 to save and 0 to cancel")
        option = getch()
        while ord(option) < 48 or ord(option) > 49:
            option = getch()
        if option == "1": save_recipe()

# equivalent of input that returns -1 instead of error if the input is not an integer
def ask(question):
    response = raw_input(question)
    try:
        float(response)
    except ValueError:
        return -1
    else:
        return float(response)

# existing menu recipe and options
def existing_recipe():
    global recipe_names, recipe
    clear()
    print("R E C I P E - T R O N\n Use Existing Recipe\n")
    find_recipe_names()
    for opt_no, recipe_name in enumerate(recipe_names):
        print opt_no+1,"-",recipe_name.title()
    print("0 - Back to Main Menu\n")
    if len(recipe_names) < 10:
        option = getch()
        while ord(option) < 48 or ord(option) > 48 + len(recipe_names):
            option = getch()
    else:
        option = ask("Which recipe would you like to use? ")
        while option < 0 or option > len(recipe_names) or int(option) != option:
            option = ask("Please only select a number from the menu: ")
    if int(option) != 0:
        people = ask("How many people are you cooking for? ")
        while people <= 0 or int(people) != people:
            people = ask("Please enter a whole number greater than zero: ")
        scale_recipe(int(option), int(people))

# the main menu
def main_menu():
    global keep_going
    clear()
    print("R E C I P E - T R O N\n      Main Menu\n")
    print("1 - Add New Recipe")
    print("2 - Use Existing Recipe")
    print("0 - Exit")
    option = getch()
    while ord(option) < 48 or ord(option) > 50:
        option = getch()
    if option == "1": new_recipe()
    if option == "2": existing_recipe()
    if option == "0": keep_going = False

# keep returning to the main menu until the user selects Exit
while keep_going:
    main_menu()
