# full explanation at https://www.tes.com/blog/programming-using-arrays-selection

def segmentise(number):
  # sum of segments required for each digit, where 1 = top, 2 = top-left, 4 = top-right, 8 = middle, 16 = bottom-left, 32 = bottom-right, 64 = bottom
  segment = (119, 36, 93, 109, 46, 107, 123, 37, 127, 111)
  # space for segment off, # for segment on
  LED = (" ","#")
  row = "\n"
  # top segment for each digit (bitwise AND with 1)
  for digit in number:
    row += "  "+LED[segment[int(digit)] & 1]*5+"   "
  print(row)
  row = ""
  # top-left (AND with 2) and top-right (AND with 4)
  for digit in number:
    row += " "+LED[segment[int(digit)] & 2 == 2]+"     "+LED[segment[int(digit)] & 4 == 4] + "  "
  # repeat three times to get vertical segments
  for n in range(3):
    print(row)
  row = ""
  # middle segment (AND with 8)
  for digit in number:
    row += "  "+LED[segment[int(digit)] & 8 == 8]*5+"   "
  print(row)
  row = ""
  # bottom-left (AND with 16) and bottom-right (AND with 32)
  for digit in number:
    row += " "+LED[segment[int(digit)] & 16 == 16]+"     "+LED[segment[int(digit)] & 32 == 32]+"  "
  for n in range(3):
    print(row)
  row = ""
  # bottom segment (AND with 64)
  for digit in number:
    row += "  "+LED[segment[int(digit)] & 64 == 64]*5+"   "
  row += "\n"
  print(row)
 
from time import sleep
from os import system

for minute in range(60):
  for second in range(60):
    # use system('clear') for Window
    system('clear')
    # zfill(n) adds leading zeros to make the number n digits long
    segmentise(str(minute).zfill(2)+str(second).zfill(2))
    sleep(1)